'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toast = require('antd-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('antd-mobile/lib/toast/style/css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AttUtil = function () {
  function AttUtil() {
    (0, _classCallCheck3.default)(this, AttUtil);
  }

  (0, _createClass3.default)(AttUtil, null, [{
    key: 'onError',


    /**
     * 处理错误
     * @param e 错误对象或者错误消息
     * @param customHandler 自定义处理函数
     */
    value: function onError(e, customHandler) {
      console.error(e);
      var errorMsg = e.message || e;
      customHandler ? customHandler(errorMsg) : '';
    }

    /**
     * 提醒弹窗延时，单位：秒
     */


    /**
     * 图片上传默认上限
     */


    /**
     * 图片base64前缀
     */


    /**
     * 视频base64前缀
     */


    /**
     * 音频base64前缀
     */


    /**
     * 音频状态码
     */
    //音频为空
    //开始
    //播放中
    //暂停

  }, {
    key: 'isBase64Data',
    //停止

    /**
     * 判断是否为base64编码数据
     */
    value: function isBase64Data(str) {
      var flag = false;
      if (str.indexOf('data:') !== -1 && str.indexOf('base64') !== -1) {
        flag = true;
      }
      return flag;
    }

    /**
     * 判断是否为存在元素的数组
     */

  }, {
    key: 'isFilledArray',
    value: function isFilledArray(obj) {
      return Array.isArray(obj) && obj.length;
    }

    /**
     * 获取图片
     * @param sourceType 图片源类型 Camera.PictureSourceType.CAMERA:相机；Camera.PictureSourceType.PHOTOLIBRARY:相册
     * @param onSucc(imageData) 成功回调(图片base64编码数据)
     * @param onFail(errorMsg) 失败回调(错误消息)
     */

  }, {
    key: 'capturePic',
    value: function capturePic(sourceType, onSucc, onFail) {
      try {
        var options = {
          sourceType: sourceType,
          destinationType: Camera.DestinationType.DATA_URL,
          encodingType: Camera.EncodingType.PNG,
          mediaType: Camera.MediaType.PICTURE,
          saveToPhotoAlbum: true,
          quality: 40,
          targetWidth: 1366,
          targetHeight: 768
        };
        var succCb = function succCb(data) {
          onSucc(data);
        };
        var failCb = function failCb(msg) {
          if (msg !== 'No Image Selected') {
            onFail ? onFail(msg) : console.error(msg);
          }
        };
        navigator.camera.getPicture(succCb, failCb, options);
      } catch (e) {
        onFail ? onFail(e) : console.error(e);
      }
    }

    /**
     * 拍照选择
     * @param onSucc(imageData) 成功回调(图片base64编码数据)
     * @param onFail(errorMsg) 失败回调(错误消息)
     */

  }, {
    key: 'capturePicByCamera',
    value: function capturePicByCamera(onSucc, onFail) {
      this.capturePic(Camera.PictureSourceType.CAMERA, onSucc, onFail);
    }

    /**
     * 相册选择
     * @param onSucc(base64data) 成功回调(照片base64数据)
     * @param onFail(errorMsg) 失败回调(错误消息)
     */

  }, {
    key: 'capturePicByAlbum',
    value: function capturePicByAlbum(onSucc, onFail) {
      this.capturePic(Camera.PictureSourceType.PHOTOLIBRARY, onSucc, onFail);
    }

    /**
     * 视频压缩
     * @param onSucc 成功回调
     * @param onFail(errorMsg) 失败回调(错误消息)
     */

  }, {
    key: 'compressVideo',
    value: function compressVideo(path, localURL, onSucc, onFail) {
      var index = path.lastIndexOf("\/");
      var fileName = path.substring(index + 1, path.length - 4);
      _toast2.default.loading('\u89C6\u9891\u5904\u7406\u4E2D');
      VideoEditor.transcodeVideo(function (result) {
        window.resolveLocalFileSystemURL('file://' + result, function (entry) {
          entry.file(function (file) {
            var reader = new FileReader();
            reader.onload = function (evt) {
              _toast2.default.hide();
              var data = evt.target.result;
              data = data.substring(data.lastIndexOf("base64") + 7, data.length);
              onSucc(data, localURL);
            };
            reader.readAsDataURL(file);
          }, function (error) {
            _toast2.default.hide();
            AttUtil.onError(error, onFail);
          });
        });
      }, function (err) {
        console.log('videoTranscodeError, err: ' + err);
        onFail ? onFail() : '';
      }, {
        fileUri: path,
        outputFileName: fileName,
        outputFileType: VideoEditorOptions.OutputFileType.MPEG4,
        optimizeForNetworkUse: VideoEditorOptions.OptimizeForNetworkUse.YES,
        saveToLibrary: true,
        maintainAspectRatio: true,
        width: 640,
        height: 640,
        videoBitrate: 1000000, // 1 megabit
        audioChannels: 2,
        audioSampleRate: 44100,
        audioBitrate: 128000, // 128 kilobits
        progress: function progress(info) {
          console.log('transcodeVideo progress callback, info: ' + info);
        }
      });
    }

    /**
     * 录像
     * @param onSucc(base64data) 成功回调(视频base64数据)
     * @param onFail(errorMsg) 失败回调(错误消息)
     */

  }, {
    key: 'captureVideo',
    value: function captureVideo(onSucc, onFail) {
      try {
        var options = {
          limit: 1,
          duration: 10,
          quality: 1
        };
        var succCb = function succCb(files) {
          var file = files[0];
          var path = file.fullPath;
          var localURL = file.localURL;
          AttUtil.compressVideo(path, localURL, onSucc, onFail);
        };
        var failCb = function failCb(error) {
          if (error.code === 3) {
            console.info('用户取消拍摄操作');
            return;
          }
          AttUtil.onError(error, onFail);
        };
        navigator.device.capture.captureVideo(succCb, failCb, options);
      } catch (e) {
        AttUtil.onError(e, onFail);
      }
    }

    /**
     * 录音
     */

  }, {
    key: 'captureAudio',
    value: function captureAudio(onSucc, onFail) {
      try {
        var options = {
          limit: 1
        };
        var succCb = function succCb(files) {
          var file = files[0];
          var path = file.fullPath;
          var localURL = file.localURL;
          window.resolveLocalFileSystemURL(path, function (entry) {
            entry.file(function (audio) {
              var reader = new FileReader();
              reader.onload = function (evt) {
                onSucc(evt.target.result, localURL);
              };
              reader.readAsDataURL(audio);
            }, function (error) {
              AttUtil.onError(error, onFail);
            });
          });
        };
        var failCb = function failCb(error) {
          if (error.code === 3) {
            console.info('用户取消录音操作');
            return;
          }
          AttUtil.onError(error, onFail);
        };
        navigator.device.capture.captureAudio(succCb, failCb, options);
      } catch (e) {
        AttUtil.onError(e, onFail);
      }
    }
  }]);
  return AttUtil;
}();

AttUtil.TOAST_DURATION = 2;
AttUtil.PIC_MAX_NUM = 4;
AttUtil.PIC_PREFIX = 'data:image/png;base64,';
AttUtil.VIDEO_PREFIX = 'data:video/mp4;base64,';
AttUtil.AUDIO_PREFIX = 'data:audio/amr;base64,';
AttUtil.MEDIA_NONE = 0;
AttUtil.MEDIA_STARTING = 1;
AttUtil.MEDIA_RUNNING = 2;
AttUtil.MEDIA_PAUSED = 3;
AttUtil.MEDIA_STOPPED = 4;
exports.default = AttUtil;
//# sourceMappingURL=AttUtil.js.map