/* 长文本组件 */
import React, {Component} from 'react'
import PropTypes from 'prop-types'
import {TextareaItem} from 'antd-mobile';
import {Header} from '../../Header/Header'

class BaseTextareaEditable extends Component {
  render() {
    const {title, rows, type, count, value, placeholder} = this.props;
    let newTitle = title && type === 'column' ? title : '';
    return (
      <div className={'zk_basetextareaeditable'}>
        {title && type !== 'column' ?
          <Header title={title} padding='15px 15px 0' bgColor='#fff'/> : ''}
        <TextareaItem
          {...this.props}
          title={newTitle}
          placeholder={placeholder || '请输入'}
          editable={true}
          clear
          value={value}
          rows={rows ? rows : 5}
          count={count ? count : 200}
        />
      </div>
    );
  }
}

class BaseTextareaNoEdit extends Component {
  render() {
    const {rows, value, type, title} = this.props;
    let newTitle = title && type === 'column' ? title : '';
    return (
      <div className={'zk_basetextareanoedit'}>
        {title && type !== 'column' ?
          <Header title={title} padding='15px 15px 0' color={'#8e8e8e'} size={'middle'}
                  bgColor={'#fff'}/> : ''}
        <TextareaItem
          {...this.props}
          title={newTitle}
          editable={false}
          value={value}
          rows={rows ? rows : 2}
        />
      </div>
    );
  }
}

export default class BaseTextarea extends Component {

  render() {
    const {editable} = this.props;
    return (
      <div className={'zk_basetextarea'}>
        {editable ? <BaseTextareaEditable {...this.props}/> : <BaseTextareaNoEdit {...this.props}/>}
      </div>
    );
  }
}

BaseTextarea.propTypes = {
  type: PropTypes.oneOf(['row', 'column']),
  title: PropTypes.string,
  editable: PropTypes.bool,
  autoHeight: PropTypes.bool,
  rows: PropTypes.number,
  count: PropTypes.number,
  placeholder: PropTypes.string,
  value: PropTypes.string,
};

