import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { List, WhiteSpace } from 'antd-mobile'
import './WithIconList.scss'
const Item = List.Item

class WithIconList extends Component {
  render () {
    const { data, itemClick } = this.props
    return (
      <List className={'zk_icon-list'}>
        {data.map((dataItem, index) => {
          return <div><Item
            data-seed='logId'
            key={index}
            thumb={dataItem.icon}
            arrow='horizontal'
            onClick={() => {
              itemClick(dataItem) || ''
            }}
          >{dataItem.value}</Item>
            <WhiteSpace size='md' />
          </div>
        })}
      </List>
    )
  }
}

WithIconList.propTypes = {
  data: PropTypes.array.isRequired,
  itemClick:PropTypes.func,
}

export default WithIconList
